/* SmoothWall install program.
 *
 * This program is distributed under the terms of the GNU General Public
 * Licence.  See the file COPYING for details.
 *
 * (c) Lawrence Manning, 2001
 * Write the config and get password stuff.
 * 
 * $Id: config.c,v 1.6.2.8 2008/05/22 22:53:12 gespinasse Exp $
 * 
 */

#include "install.h"

extern char **ctr;	// text translation table

/* called to write out all config files using the keyvalue interface. */
int write_disk_configs(struct devparams *dp)
{
	char devnode[STRING_SIZE];
	char partition[STRING_SIZE];
	char message[STRING_SIZE];

	/* dev node links. */
	sprintf(devnode, "%s", dp->devnode_disk_run);
	if (symlink(devnode, "/harddisk/dev/harddisk"))
	{
		errorbox(ctr[TR_UNABLE_TO_MAKE_SYMLINK_DEV_HARDDISK]);
		return 0;
	}

	int j;
	for (j=1; j<6; j++) {
		sprintf(devnode, "%s%d", dp->devnode_part_run,j);
		sprintf(partition,"/harddisk/dev/harddisk%d",j);
		if (symlink(devnode, partition))
		{
			sprintf( message, ctr[TR_UNABLE_TO_MAKE_SYMLINK_DEV_HARDDISK]);
			strcat( message, " %d");
			sprintf( message, message, j);
			errorbox( message );
			return 0;
		}
	}

	/* Add /dev/root symlink linking to the root filesystem to 
	 * keep updfstab happy */
	sprintf(devnode, "%s4", dp->devnode_part_run);
	if (symlink(devnode, "/harddisk/dev/root"))
	{
		errorbox(ctr[TR_UNABLE_TO_MAKE_SYMLINK_DEV_ROOT]);
		return 0;
	}

	return 1;
}

int write_lang_configs( char *lang)
{
	struct keyvalue *kv = initkeyvalues();

	/* default stuff for main/settings. */
	replacekeyvalue(kv, "LANGUAGE", lang);
	replacekeyvalue(kv, "HOSTNAME", SNAME);
	writekeyvalues(kv, "/harddisk" CONFIG_ROOT "/main/settings");
	freekeyvalues(kv);


	/* initial language for VPN certs */
	char temp[STRING_SIZE];
	int i;
	for (i=0; *lang; lang++, i++) {
		temp[i] = toupper(*lang);
	}
	temp[i] = '\0';
	kv = initkeyvalues();
	readkeyvalues(kv, "/harddisk" CONFIG_ROOT "/vpn/settings");
	replacekeyvalue(kv, "ROOTCERT_COUNTRY", temp);
	writekeyvalues(kv, "/harddisk" CONFIG_ROOT "/vpn/settings");
	freekeyvalues(kv);

	return 1;
}

int write_ethernet_configs(struct keyvalue *ethernetkv)
{
	/* Write out the network settings we got from a few mins ago. */
	writekeyvalues(ethernetkv, "/harddisk" CONFIG_ROOT "/ethernet/settings");
	return 1;
}
