/*
 * This file is part of the IPCop Firewall.
 *
 * IPCop is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * IPCop is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with IPCop; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * Copyright (C) 2006-10-06 Achim Weber
 *
 * $Id: settimenow.c,v 1.2.2.2 2007/03/22 10:37:23 dotzball Exp $
 *
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "setuid.h"


/* define parameters */
#define PARA_CLEAN		"clean"
#define PARA_INIT		"init"

int main(int argc, char**argv)
{

	if (!(initsetuid()))
		return 1;

	// What should we do?
	if (argc==1)
	{
		safe_system("/bin/touch /var/log/time/settimenow");
		safe_system("/usr/local/bin/timecheck");
		return 0;
	}
	else if (argc==2 && strcmp(argv[1], PARA_CLEAN)==0)
	{
		safe_system("/bin/rm -f /var/log/time/settimenow");
		safe_system("/bin/rm -f /var/log/time/counter");
		return 0;
	}
	else if (argc==2 && strcmp(argv[1], PARA_INIT)==0)
	{
		safe_system("/bin/cp " CONFIG_ROOT "/time/counter.conf /var/log/time/counter");
		return 0;
	}


	fprintf (stderr, "Bad parameter!\n");
	return 1;
}
