#!/usr/bin/perl
#
# This file is part of the IPCop Firewall.
# (c) Gilles Espinasse
#
# strip script work with settings selected from update page
# done
# - remove unselected kernels
# - on grub menu, unusable options are not removed
# warning : changing grub menu would invalidate the registered savedefault
# not yet done
# - could remove unused scsi drivers if unused (1.4 MB per kernel)
# - could remove unused langs ( twice 1.5 MB) on CONFIG_ROOT/langs and /var/run/cache-langs*.pl


# $Id: strip.pl,v 1.1.2.2 2008/07/22 10:24:33 gespinasse Exp $

use strict;

# enable only the following on debugging purpose
#use warnings; no warnings 'once';# 'redefine', 'uninitialized';

require 'CONFIG_ROOT/general-functions.pl';
use POSIX qw(uname);

my %settings=();
$settings{'KERNEL'} = '';
&General::readhash("${General::swroot}/main/kernelsettings", \%settings);

my $kernelused='monoprocessor';
$kernelused='smp' if ((POSIX::uname())[2] =~ /smp/);

my $CANTREMOVE="Can not remove kernel type '$kernelused' currently in use.";

if ($settings{'KERNEL'} eq 'MONO') {
	if ($kernelused eq 'monoprocessor') {
		General::log('update',"Removing smp kernel type");
		system('/bin/rm -rf /lib/modules/2.4.??-smp');
		system('/bin/rm -f /boot/System.map-2.4.??-smp');
		system('/bin/rm -f /boot/ipcoprd{,-2.4.??}-smp.img');
		system('/bin/rm -f /boot/vmlinuz{,-2.4.??}-smp');
	} else {
		General::log($CANTREMOVE);
	}
} elsif ($settings{'KERNEL'} eq 'SMP') {
	if ($kernelused eq 'smp') {
		General::log('update',"Removing monoprocessor kernel type");
		system('/bin/rm -rf /lib/modules/2.4.??');
		system('/bin/rm -f /boot/System.map-2.4.??');
		system('/bin/rm -f /boot/ipcoprd{,-2.4.??}.img');
		system('/bin/rm -f /boot/vmlinuz{,-2.4.??}');
	} else {
		General::log($CANTREMOVE);
	}
} else {
	exit(0);
}

my @config=('');
if (open(GRUBCONF, '</boot/grub/grub.conf')) {
	@config= <GRUBCONF>;
	close(GRUBCONF);
}
open(GRUBCONF, '>/boot/grub/grub.conf') || die 'Unable to rewrite grub.conf';

my $start_marks="(^title IPCop SMP|^title IPCop old .*smp)";
 if ($kernelused eq 'smp') {
	$start_marks='(^title IPCop$|^title IPCop \(ACPI enabled|^title IPCop old.*\d\d\)|^title IPCop old.*\d\d ACPI)';
}

my $lines=0;
foreach my $confline ((@config)) {
	if ($confline =~ m!$start_marks! || $lines>0) {
		$lines++;
		#print "match /$lines\n";
	} else {
		#print "no match /$lines\n";
		print GRUBCONF $confline;
	}
	$lines=0 if ($confline =~ m!savedefault$!); # mark end of block
}
close(GRUBCONF);
