#!/bin/bash
#
# Create a ROOTFILE using log files
# - start script from ipcop tree => ./tools/create_rootfiles.sh
# - then check  diff -Nur ROOTFILES.<machine> src/ROOTFILES.<machine>
#
# If you need to create src/ROOTFILES.<machine> for a different arch
# - copy src/ROOFILES.i386 to corresponding src/ROOFILES.<machine>
# - you have next to manually comment/uncomment new (from i386 build) files

MACHINE=`uname -m`
  if [ 'i686' = $MACHINE -o 'i586' = $MACHINE -o 'i486' = $MACHINE -o 'i386' = $MACHINE ]; then
	echo "`date -u '+%b %e %T'`: Machine is ix86 (or equivalent)"
	MACHINE=i386
  elif [ 'alpha' = $MACHINE ]; then
	echo "`date -u '+%b %e %T'`: Machine is Alpha AXP"
  elif [ 'ppc' = $MACHINE ]; then
	echo "`date -u '+%b %e %T'`: Machine is PowerPC"
  elif [ 'sparc' = $MACHINE ]; then
	echo "`date -u '+%b %e %T'`: Machine is Sparc"
  else
	echo "`date -u '+%b %e %T'`: Can't determine your architecture - $MACHINE"
	echo "Please report your result if that work"
  fi

VERSION=`grep VERSION --max-count=1 make.sh | cut -d '"' -f2`

rm -f /tmp/ROOTFILES-$MACHINE

# read list of target files except log/_* in reverse time ordered list
# result is send to ./ROOTFILES.$MACHINE
cd log
for i in `ls -c1tr [^_]*`; do
	case $i in
	FILES|scsi-${VERSION}.img|driver-${VERSION}.img|diskutils-${VERSION})
		echo "Skipping $i"
		;;
	*)
		if [ -s $i ]; then
			echo "##" | tee -a ../ROOTFILES.$MACHINE
			echo "## $i" | tee -a ../ROOTFILES.$MACHINE
			cat ../log*/$i | tee -a ../ROOTFILES.$MACHINE
		else
			echo "Skipping $i : 0 size"
		fi
		;;
	esac
done
