#!/usr/bin/perl
#
# This file is part of the IPCop Firewall.
#
# IPCop is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# IPCop is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with IPCop; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
# Copyright (C) 2003-03-09 Mark Wormgoor <mark@wormgoor.com>
#
my $st="                         ";
open(LIST, "./langs/list") or die 'Unable to open language list ./langs/list';

while (<LIST>) {
	next if $_ =~ m/^#/;
	@temp = split(/:/,$_);
	$lang = $temp[0];
	$uclang = uc($lang);
	print substr("Downloading files for $temp[1] $lang $st", 0, 45);
	my $new_file="create-pl.php?Lang=${uclang}";
	my $new_md5="";
	my $old_file="langs/${lang}/cgi-bin/${lang}.pl";
	my $old_md5="";
	system ('wget','--quiet','-N','-c','--cache=off',"http://www.ipcop.org/langs/$new_file");
	$new_md5=`md5sum $new_file | cut -d ' ' -f 1`;
	if (-f "$old_file") {
		$old_md5=`md5sum $old_file | cut -d ' ' -f 1`;
	}
	if ("$old_md5" ne "$new_md5") {
		rename ("$new_file", "$old_file") or die
			'Failed to rename downloaded file: $old_file';
		print " web:done  \t";
	} else {
		print " web:passed\t";
		unlink($new_file);
	}
	# do not stop if a lang has no install file
	if (-e "langs/${lang}/install") {
		$new_file="create-c.php?Lang=${uclang}";
		$new_md5="";
		$old_file="langs/${lang}/install/lang_${lang}.c";
		$old_md5="";
		system ('wget','--quiet','-N','-c','--cache=off',"http://www.ipcop.org/langs/$new_file");
		$new_md5=`md5sum $new_file | cut -d ' ' -f 1`;
		if (-f "$old_file") {
			$old_md5=`md5sum $old_file | cut -d ' ' -f 1`;
		}
		if ("$old_md5" ne "$new_md5") {
			rename ("$new_file", "$old_file") or die
				'Failed to rename downloaded file: $old_file';
			print " install:done  \n";
		} else {
			print " install:passed\n";
			unlink($new_file);
		}
	} else {
		print " install:not yet \n";
	}
}
close (LIST)
