#!/usr/bin/perl
#
# Input Language Data File from hashes
#
# This file is part of the IPCop Firewall.
#
# IPCop is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# IPCop is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with IPCop; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
# # IPCop translation
# (c) 2004 Arnt Karlsen, Rebecca Ward,
# (c) 2004 Dr. Michael Spann (just for this script), improvements welcome
#
# The script imports the language.pl file in the www-form on http://www.ipcop.org/langs/edit/edit.php.
# Please be carefull when editing the language.pl files. You have to save all commas. If you have there any
#  errors, this script will write the line of the error to stdout. (works perfectly as an cgi in the webbrowser).
# Not tested with perl in native bash - mode.
# Please report errors to no_-spam-_spann@gmx.de. Thanks.

# $Id: updatelang.pl,v 1.1.2.2 2007/08/02 23:05:07 franck78 Exp $



use strict;
#use CGI::Carp qw(fatalsToBrowser);
use HTTP::Request::Common qw(GET POST);
use LWP::UserAgent;
use HTML::Form;

sub readhash
{
	my $filename = $_[0];
	my $hash = $_[1];
	my ($var, $val);
	
	
	# Some ipcop code expects that readhash 'complete' the hash if new entries
	# are presents. Not clear it !!!
	#%$hash = ();

	if (!open(FILE, $filename)) {
	    open (FILE, ">$filename");
	    print FILE "#you can erase the password key\n";

	    foreach my $k (keys (%$hash) ) {
	        print FILE "$k = '$hash->{$k}'\n";
	    }
	    close FILE;
	    die "Default config file ($filename) created, FILL it !";
	}

	while (<FILE>)
	{
		chop;
		($var, $val) = split /=/, $_, 2;
		if ($var)
		{
			$val =~ s/^ *\'//g;
			$val =~ s/\' *$//g;

			# Untaint variables read from hash
			$var =~ /([A-Za-z0-9_-]*)/;
			$var = $1;
			$val =~ /([\w\W]*)/;
			$hash->{$var} = $1;
		}
	}
	close FILE;
}

my %setup;
$setup{'user'} = 'your ipcop.org username';
$setup{'password'} = 'your ipcop.org password';
$setup{'language'} = 'EN or any valid language code';
$setup{'datafile'} = 'file containinig hash to insert';

# Put in this config file the language file path to include
# in order to include the %tr or any other hashes...
# Put also the ipcop.org username and password
readhash ('updatelang.conf', \%setup);
die "Fill in config file !!!\n" if ( ($setup{'user'} eq 'your ipcop.org username') );

our %tr=();
require $setup{'datafile'};

if ( $setup{'password'} eq 'your ipcop.org password' ){ 
    print "Enter your ipcop.org password:";
    use Term::ReadKey;
    ReadMode 'noecho';
    $setup{'password'} = ReadLine 0;
    ReadMode 'normal';
    chomp $setup{'password'};
}

# This is the demo data to test the correct working of the script, especially user authentification
# %tr = (
# 'cannot specify secondary dns without specifying primary' => 'Ma shaqaysinkaro labad inta aanan khaasyelin kowbaad.'
# );


my $ua = LWP::UserAgent->new;
my $i = 0;
my $updated = 0;
my $not_updated = 0;

# do the job
foreach my $key_entry ( keys (%tr)) {
    $i++;

    # read current value for this entry
    my $content_send = "VarName=$key_entry&Language=$setup{'language'}";

    my $req = HTTP::Request->new(GET => 'http://www.ipcop.org/langs/edit/edit.php?'.$content_send);
    $req->authorization_basic($setup{'user'}, $setup{'password'});
    $req->content_type('application/x-www-form-urlencoded');

    my @forms = HTML::Form->parse($ua->request($req));
    my $form = shift @forms;
    use bytes;
    my $v = $form->value('NewWord');
    print "$i :: $key_entry :: $tr{$key_entry} :: $v ::";

    if ($v eq $tr{$key_entry}) {
	print "is up to date\n";
	$not_updated++;
	no bytes;
	next;
    };
    no bytes;
    if (@ARGV && @ARGV[0] eq '-w' ) { # -w write specified

        # create the POST
	$req = HTTP::Request->new(POST => 'http://www.ipcop.org/langs/edit/edit.php');
	$req->content_type('application/x-www-form-urlencoded');
	$req->content($content_send . "&Update=UPDATE&NewWord=$tr{$key_entry}");
	$req->authorization_basic($setup{'user'}, $setup{'password'});

	my $res = $ua->request($req);
	if ($res->is_success) {
	    print "updated\n";
	    $updated++
        } else {
	    print  $res->status_line ."\n";
	    die "Error occured sending line $i. Please correct error, [optional:cut your datafile til this line and retry].\nEntries updated:$updated\nEntries uptodate:$not_updated\n";
	}
    } else {
	print "ok\n";
    }
}
print "Done...\nEntries  updated:$updated\nEntries uptodate:$not_updated\n";
