#!/usr/bin/perl

use strict;
use File::Copy;
use Sys::Hostname;

my $newdir = '/home/httpd/html/backup';	# location where sets are stored and imported
my $olddir = '/var/ipcop/backup/sets';	# previous location
my $hostname=&hostname();
my $set = "$newdir/$hostname";

# remove old selected set
system('/bin/rm -f', "$set.dat", "$set.dat.time", "$set.tar.gz", "$set.tar.gz.time");

# upgrade old format
foreach my $olddat (`/bin/ls -tR1 $olddir/*/*.dat 2>/dev/null`) {
	#remove newline
	chop ($olddat);
	my $newdat = $olddat;
	$newdat =~ s/^($olddir)\/(\d{4})(\d{2})(\d{2})_(\d{2})(\d{2})(\d{2})\/($hostname)\.dat$/$set-$2-$3-$4_$5-$6-$7\.dat/;
	#print "$olddat :=> $newdat\n";
	move ($olddat, $newdat);
	open(outfile, ">$newdat.time");
	print outfile "$2-$3-$4_$5-$6-$7 ";
	close(outfile);
	chown 99,99, "$newdat.time";
}
